Console.Clear();

var xmldoc = new ActiveXObject("Microsoft.XMLDOM");
xmldoc.onreadystatechange = HandleReadyState
xmldoc.ondataavailable = HandleData
xmldoc.validateOnParse = true;
xmldoc.loadXML( Document.Text );

function HandleData()
{
    var count = xmldoc.childNodes.length;
    var root = xmldoc.documentElement;
    if (root != null)
    {
        count += root.childNodes.length;
    }
    Document.WriteLine( "Loaded " + count + " nodes" );
}

function HandleReadyState()
{
    if (xmldoc.readyState == 4)
    {
        if (xmldoc.childNodes.length == 0)
        {
            HandleError(xmldoc);
        }
        else
        {
            Console.WriteLine( "Your XML is well formed and is validated" );
        }
    }
}

function FormatErrorCode(rc)
{
    if (rc < 0) rc = (65536*65536) + rc;
    return "0x" + rc.toString(16).toUpperCase();
}

function HandleError()
{
    var err = xmldoc.parseError;
    var msg = Document.FullName;
    msg += "(" + err.line + "," + err.linepos + ") : ";
    msg += "error " + FormatErrorCode(err.errorCode);
    msg += ": " + err.reason + " in " + err.url;

	Console.WriteLineColor( msg, 192 );
    
    var code = "";
    if (err.linepos > 0 && err.srcText != "")
    {
        code = err.srcText.replace(/\t/g," ") + "\n";
        for (var i = 1; i < err.linepos; i++)
        {
            code += "-";
        }
        code += "^";
    }
    Console.WriteLine( code );
}
